# Module: `wibox.layout.stack`

Place multiple widgets on top of each other.

This layout display widgets on top of each other. It can be used to overlay a wibox.widget.textbox on top of a `awful.widget.progressbar` or manage "pages" where only one is visible at any given moment.

The indices are going from 1 (the bottom of the stack) up to the top of the stack. The order can be changed either using `:swap` or `:raise`.

### Usage:

    wibox.widget {
        generic_widget( "first"  ),
        generic_widget( "second" ),
        generic_widget( "third"  ),
        layout  = wibox.layout.stack
    }

### Class Hierarchy

- gears.object
- - wibox.widget.base
  - - wibox.layout.fixed
    - - wibox.layout.stack

### Info:

- Copyright: 2016 Emmanuel Lepage Vallee
- Originally authored by: Emmanuel Lepage Vallee
  (Full contributors list available on our github project)

## Constructors

wibox.layout.stack () | Create a new stack layout. |

## Object properties

spacing | number | Add spacing around the widget, similar to the margin container. |
top_only | boolean | If only the first stack widget is drawn. |
horizontal_offset | number | Add an horizontal offset to each layers. |
vertical_offset | number | Add an vertical offset to each layers. |
spacing_widget | widget or nil | A widget to insert as a separator between child widgets. | Inherited from wibox.layout.fixed
fill_space | boolean | Set the layout's fill_space property. | Inherited from wibox.layout.fixed
children | table | Get or set the children elements. | Inherited from wibox.widget.base
all_children | table | Get all direct and indirect children widgets. | Inherited from wibox.widget.base
forced_height | number or nil | Force a widget height. | Inherited from wibox.widget.base
forced_width | number or nil | Force a widget width. | Inherited from wibox.widget.base
opacity | number | The widget opacity (transparency). | Inherited from wibox.widget.base
visible | boolean | The widget visibility. | Inherited from wibox.widget.base
buttons | table | The widget buttons. | Inherited from wibox.widget.base

## Object methods

:add (...) | Add some widgets to the given stack layout. |
:remove (index) -> boolean | Remove a widget from the layout. |
:insert (index, widget) -> boolean | Insert a new widget in the layout at position `index`. |
:remove_widgets (widget) -> boolean | Remove one or more widgets from the layout. |
:raise (index) | Raise a widget at `index` to the top of the stack. |
:raise_widget (widget, recursive) | Raise the first instance of `widget`. |
:set (index, widget2) -> boolean | Set a widget at a specific index, replacing the current one. |
:replace_widget (widget, widget2, recursive) -> boolean | Replace the first instance of `widget` in the layout with `widget2`. |
:swap (index1, index2) -> boolean | Swap 2 widgets in a layout. |
:swap_widgets (widget1, widget2, recursive) -> boolean | Swap 2 widgets in a layout. |
:reset () | Reset the layout. |
:add_button (button) | Add a new awful.button to this widget. | Inherited from wibox.widget.base
:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. | Inherited from wibox.widget.base
:index (widget, recursive, ...) -> (number, widget, table) | Get the index of a widget. | Inherited from wibox.widget.base
:connect_signal (name, func) | Connect to a signal. | Inherited from gears.object
:weak_connect_signal (name, func) | Connect to a signal weakly. | Inherited from gears.object
:disconnect_signal (name, func) | Disconnect from a signal. | Inherited from gears.object
:emit_signal (name, ...) | Emit a signal. | Inherited from gears.object

## Signals

widget::layout_changed | When the layout (size) change. | Inherited from wibox.widget.base
widget::redraw_needed | When the widget content changed. | Inherited from wibox.widget.base
button::press | When a mouse button is pressed over the widget. | Inherited from wibox.widget.base
button::release | When a mouse button is released over the widget. | Inherited from wibox.widget.base
mouse::enter | When the mouse enter a widget. | Inherited from wibox.widget.base
mouse::leave | When the mouse leave a widget. | Inherited from wibox.widget.base

## Constructors

🔗 wibox.layout.stack ()
  Create a new stack layout.

  ### Returns:

  widget A new stack layout

## Object properties

🔗 spacing number · 1 signal
  Add spacing around the widget, similar to the margin container.

  ### Constraints:

  Default value | : `0`
  Unit | : pixel
  Negative allowed | : false
  Valid values | : Spacing between widgets.

  ### Usage:

      wibox.widget {
          generic_widget( "first"  ),
          generic_widget( "second" ),
          generic_widget( "third"  ),
          spacing = 6,
          layout  = wibox.layout.stack
      }

  Click to display more

  ### Emit signals:

  - `property::spacing` When the spacing value changes.
  - `self` wibox.layout.stack The object which changed (useful when connecting many object to the same callback).
  - `new_value` spacing The new value affected to the property.
🔗 top_only boolean · 1 signal
  If only the first stack widget is drawn.

  ### Constraints:

  Default value | : `false`
  Valid values | : `true` or `false`.

  Click to display more

  ### Emit signals:

  - `property::top_only` When the top_only value changes.
  - `self` wibox.layout.stack The object which changed (useful when connecting many object to the same callback).
  - `new_value` top_only The new value affected to the property.
🔗 horizontal_offset number · 1 signal
  Add an horizontal offset to each layers.

  Note that this reduces the overall size of each widgets by the sum of all layers offsets.

  ### Constraints:

  Default value | : `0`
  Unit | : pixel
  Negative allowed | : true

  ### See also:

  vertical_offset | Add an vertical offset to each layers. | object properties

  ### Usage:

      wibox.widget {
          generic_widget( "first"  ),
          generic_widget( "second" ),
          generic_widget( "third"  ),
          horizontal_offset = 5,
          vertical_offset   = 5,
          layout            = wibox.layout.stack
      }

  Click to display more

  ### Emit signals:

  - `property::horizontal_offset` When the horizontal_offset value changes.
  - `self` wibox.layout.stack The object which changed (useful when connecting many object to the same callback).
  - `new_value` horizontal_offset The new value affected to the property.
🔗 vertical_offset number · 1 signal
  Add an vertical offset to each layers.

  Note that this reduces the overall size of each widgets by the sum of all layers offsets.

  ### Constraints:

  Default value | : `0`
  Unit | : pixel
  Negative allowed | : true

  ### See also:

  horizontal_offset | Add an horizontal offset to each layers. | object properties

  Click to display more

  ### Emit signals:

  - `property::vertical_offset` When the vertical_offset value changes.
  - `self` wibox.layout.stack The object which changed (useful when connecting many object to the same callback).
  - `new_value` vertical_offset The new value affected to the property.
🔗 spacing_widget widget or nil · Inherited from wibox.layout.fixed · 1 signal
  A widget to insert as a separator between child widgets.

  If this property is a valid widget and spacing is greater than `0`, a copy of this widget is inserted between each child widget, with its size in the layout's main direction determined by spacing.

  By default no widget is used and any spacing is applied as an empty offset.

  ### Constraints:

  Default value | : `nil`

  ### Usage:

      -- Use the separator widget directly
      local w1 = wibox.widget {
          spacing        = 10,
          spacing_widget = wibox.widget.separator,
          layout         = wibox.layout.fixed.horizontal
      }
      -- Use a standard declarative widget construct
      local w2 = wibox.widget {
          spacing = 10,
          spacing_widget = {
              color  = "#00ff00",
              shape  = gears.shape.circle,
              widget = wibox.widget.separator,
          },
          layout = wibox.layout.fixed.horizontal
      }
      -- Use composed widgets
      local w3 = wibox.widget {
          spacing = 10,
          spacing_widget = {
              {
                  text   = "F",
                  widget = wibox.widget.textbox,
              },
              bg     = "#ff0000",
              widget = wibox.container.background,
          },
          layout = wibox.layout.fixed.horizontal
      }
      -- Use negative spacing to create a powerline effect
      local w4 = wibox.widget {
          spacing = -12,
          spacing_widget = {
              color  = "#ff0000",
              shape  = gears.shape.powerline,
              widget = wibox.widget.separator,
          },
          layout = wibox.layout.fixed.horizontal
      }

  Click to display more

  ### Emit signals:

  - `property::spacing_widget` When the `spacing_widget` value changes.
  - `self` wibox.layout.fixed The object which changed (useful when connecting many object to the same callback).
  - `new_value` `spacing_widget` The new value affected to the property.
🔗 fill_space boolean · Inherited from wibox.layout.fixed · 1 signal
  Set the layout's fill_space property. If this property is true, the last widget will get all the space that is left. If this is false, the last widget won't be handled specially and there can be space left unused.

  ### Constraints:

  Default value | : `false`
  Valid values | : `true` or `false`.

  Click to display more

  ### Emit signals:

  - `property::fill_space` When the `fill_space` value changes.
  - `self` wibox.layout.fixed The object which changed (useful when connecting many object to the same callback).
  - `new_value` `fill_space` The new value affected to the property.
🔗 children table · Inherited from wibox.widget.base
  Get or set the children elements.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.all_children |  |

🔗 all_children table · Inherited from wibox.widget.base
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow if there is a loop in the widgets hierarchy. A hierarchy loop is when a widget, or any of its children, contain (directly or indirectly) itself.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.children |  |

🔗 forced_height number or nil · Inherited from wibox.widget.base
  Force a widget height.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the height. Usually using the widget native height.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_width |  |

🔗 forced_width number or nil · Inherited from wibox.widget.base
  Force a widget width.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the width. Usually using the widget native width.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_height |  |

🔗 opacity number · Inherited from wibox.widget.base
  The widget opacity (transparency).

  ### Constraints:

  Default value | : `1.0`
  Unit | : A gradient between transparent (`0.0`) and opaque (`1.0`).
  Minimum value | : 0.0
  Maximum value | : 1.0

  ### See also:

  wibox.widget.base.visible |  |

🔗 visible boolean · Inherited from wibox.widget.base
  The widget visibility.

  ### Constraints:

  Default value | : `true`
  Valid values | : `true` or `false`.

  ### See also:

  wibox.widget.base.opacity |  |

🔗 buttons table · Inherited from wibox.widget.base
  The widget buttons.

  The table contains a list of awful.button objects.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of awful.button.

  ### See also:

  awful.button | Create easily new buttons objects ignoring certain modifiers. | module

## Object methods

🔗 :add (...)
  Add some widgets to the given stack layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  ... |  | widget | Widgets that should be added (must at least be one)

🔗 :remove (index) -> boolean
  Remove a widget from the layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The widget index to remove

  ### Returns:

  boolean index If the operation is successful
🔗 :insert (index, widget) -> boolean · 1 signal
  Insert a new widget in the layout at position `index`.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The position
  widget |  | widget | The widget

  ### Returns:

  boolean If the operation is successful
  Click to display more

  ### Emit signals:

  - `widget::inserted`
  - `self` `widget` The fixed layout.
  - `widget` `widget` index The inserted widget.
  - `count` `number` The widget count.
🔗 :remove_widgets (widget) -> boolean
  Remove one or more widgets from the layout.

  The last parameter can be a boolean, forcing a recursive seach of the widget(s) to remove.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | ... Widgets that should be removed (must at least be one)

  ### Returns:

  boolean If the operation is successful
🔗 :raise (index)
  Raise a widget at `index` to the top of the stack.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The widget index to raise

🔗 :raise_widget (widget, recursive)
  Raise the first instance of `widget`.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget |  | widget | The widget to raise | Not applicable
  recursive | Optional | boolean | Also look deeper in the hierarchy to find the widget | `false`

🔗 :set (index, widget2) -> boolean · 1 signal
  Set a widget at a specific index, replacing the current one.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | A widget or a widget index
  widget2 |  | widget | The widget to replace the previous one with

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::replaced`
  - `self` `widget` The layout.
  - `widget` `widget` The inserted widget.
  - `previous` `widget` The previous widget.
  - `index` `number` The replaced index.
🔗 :replace_widget (widget, widget2, recursive) -> boolean · 1 signal
  Replace the first instance of `widget` in the layout with `widget2`.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget |  | widget | The widget to replace | Not applicable
  widget2 |  | widget | The widget to replace `widget` with | Not applicable
  recursive | Optional | boolean | Recurse into all compatible layouts to find the widget. | `false`

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::replaced`
  - `self` `widget` The layout.
  - `widget` `widget` index The inserted widget.
  - `previous` `widget` The previous widget.
  - `index` `number` The replaced index.
🔗 :swap (index1, index2) -> boolean · 1 signal
  Swap 2 widgets in a layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index1 |  | number | The first widget index
  index2 |  | number | The second widget index

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::swapped`
  - `self` `widget` The layout.
  - `widget1` `widget` The first widget.
  - `widget2` `widget` The second widget.
  - `index1` `number` The first index.
  - `index1` `number` The second index.
🔗 :swap_widgets (widget1, widget2, recursive) -> boolean · 1 signal
  Swap 2 widgets in a layout.

  If `widget1` is present multiple time, only the first instance is swapped.

  Calls set internally, so the signal `widget::replaced` is emitted for both widgets as well.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget1 |  | widget | The first widget | Not applicable
  widget2 |  | widget | The second widget | Not applicable
  recursive | Optional | boolean | Recurse into all compatible layouts to find the widget. | `false`

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.

  ### See also:

  set | Set a widget at a specific index, replacing the current one. | object methods

  Click to display more

  ### Emit signals:

  - `widget::swapped`
  - `self` `widget` The layout.
  - `widget1` `widget` The first widget.
  - `widget2` `widget` The second widget.
  - `index1` `number` The first index.
  - `index1` `number` The second index.
🔗 :reset () · 1 signal
  Reset the layout. This removes all widgets from the layout.
  Click to display more

  ### Emit signals:

  - `widget::reset`
  - `self` `widget` The layout.
🔗 :add_button (button) · Inherited from wibox.widget.base
  Add a new awful.button to this widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  button |  | awful.button | The button to add.

🔗 :emit_signal_recursive (signal_name, ...) · Inherited from wibox.widget.base
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.

  This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.

  Note that this function has some flaws:

  1. The signal is only forwarded once the widget tree has been built. This happens after all currently scheduled functions have been executed. Therefore, it will not start to work right away. 2. In case the widget is present multiple times in a single widget tree, this function will also forward the signal multiple times (once per upward tree path). 3. If the widget is removed from the widget tree, the signal is still forwarded for some time, similar to the first case.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  signal_name |  | string |
  ... |  |  | Other arguments

🔗 :index (widget, recursive, ...) -> (number, widget, table) · Inherited from wibox.widget.base
  Get the index of a widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to look for.
  recursive | Optional | boolean | Recursively check accross the sub-widgets hierarchy.
  ... | Optional | widget | Additional widgets to add at the end of the sub-widgets hierarchy "path".

  ### Returns:

  1. number The widget index.
  2. widget The parent widget.
  3. table The hierarchy path between "self" and "widget".
🔗 :connect_signal (name, func) · Inherited from gears.object
  Connect to a signal.

  **Usage example output**:

  In slot [obj] nil nil nil In slot [obj] foo bar 42

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

  ### Usage:

      local o = gears.object{}
      -- Function can be attached to signals
      local function slot(obj, a, b, c)
          print("In slot", obj, a, b, c)
      end
      o:connect_signal("my_signal", slot)
      -- Emitting can be done without arguments. In that case, the object will be
      -- implicitly added as an argument.
      o:emit_signal "my_signal"
      -- It is also possible to add as many random arguments are required.
      o:emit_signal("my_signal", "foo", "bar", 42)
      -- Finally, to allow the object to be garbage collected (the memory freed), it
      -- is necessary to disconnect the signal or use weak_connect_signal
      o:disconnect_signal("my_signal", slot)
      -- This time, the slot wont be called as it is no longer connected.
      o:emit_signal "my_signal"

🔗 :weak_connect_signal (name, func) · Inherited from gears.object
  Connect to a signal weakly.

  This allows the callback function to be garbage collected and automatically disconnects the signal when that happens. **Warning:** Only use this function if you really, really, really know what you are doing.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

🔗 :disconnect_signal (name, func) · Inherited from gears.object
  Disconnect from a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback that should be disconnected.

🔗 :emit_signal (name, ...) · Inherited from gears.object
  Emit a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal
  ... |  |  | Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal()

## Signals

🔗 widget::layout_changed · Inherited from wibox.widget.base
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed | When the widget content changed. | signals

🔗 widget::redraw_needed · Inherited from wibox.widget.base
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed | When the layout (size) change. | signals

🔗 button::press · Inherited from wibox.widget.base
  When a mouse button is pressed over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 button::release · Inherited from wibox.widget.base
  When a mouse button is released over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::enter · Inherited from wibox.widget.base
  When the mouse enter a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::leave · Inherited from wibox.widget.base
  When the mouse leave a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

generated by LDoc 1.5.0